Index: /trunk/src/org/expeditee/gui/FrameGraphics.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameGraphics.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameGraphics.java	(revision 1102)
@@ -936,23 +534,22 @@
 			// For polygons need to make sure all other endpoints are
 			// unHighlighted
-			if (i.hasPermission(UserAppliedPermission.full))
-				changeHighlightMode(i, Item.HighlightMode.Normal,
-						Item.HighlightMode.None);
-			else
-				changeHighlightMode(i, Item.HighlightMode.Connected,
-						Item.HighlightMode.Connected);
-		}
-		Repaint();
+			if (i.hasPermission(UserAppliedPermission.full)) {
+				changeHighlightMode(i, Item.HighlightMode.Normal, Item.HighlightMode.None);
+			} else {
+				changeHighlightMode(i, Item.HighlightMode.Connected, Item.HighlightMode.Connected);
+			}
+		}
+		DisplayController.requestRefresh(true);
 		return i;
 	}
 
-	public static void changeHighlightMode(Item item, Item.HighlightMode newMode) {
+	public static void changeHighlightMode(Item item, Item.HighlightMode newMode)
+	{
 		changeHighlightMode(item, newMode, newMode);
 	}
 
-	public static void changeHighlightMode(Item item,
-			Item.HighlightMode newMode, Item.HighlightMode connectedNewMode) {
-		if (item == null)
-			return;
+	public static void changeHighlightMode(Item item, Item.HighlightMode newMode, Item.HighlightMode connectedNewMode)
+	{
+		if (item == null) return;
 
 		if (item.hasVector()) {
@@ -960,222 +557,33 @@
 				if (i.getEditTarget() == item) {
 					i.setHighlightMode(newMode);
+					i.setHighlightColorToDefault();
 				}
 			}
 			item.setHighlightMode(newMode);
+			item.setHighlightColorToDefault();
 		} else {
 			// Mike: TODO comment on why the line below is used!!
-			// I forgot already!!Opps
+			// I forgot already!! Oops
 			boolean freeItem = FreeItems.getInstance().contains(item);
 			for (Item i : item.getAllConnected()) {
 				if (/* freeItem || */!FreeItems.getInstance().contains(i)) {
 					i.setHighlightMode(connectedNewMode);
-				}
-			}
-			if (!freeItem && newMode != connectedNewMode)
+					i.setHighlightColorToDefault();
+				}
+			}
+			if (!freeItem && newMode != connectedNewMode) {
 				item.setHighlightMode(newMode);
-		}
-		Repaint();
-	}
-
-	/**
-	 * Repaints the buffer of the given Frame.
-	 * 
-	 * @param toUpdate
-	 *            The Frame whose buffer is to be repainted.
-	 */
-
-	public static void UpdateBuffer(Frame toUpdate, boolean paintOverlays,
-			boolean useVolitile) {
-		toUpdate.setBuffer(getBuffer(toUpdate, paintOverlays, useVolitile));
-	}
-
-	public static Image getBuffer(Frame toUpdate, boolean paintOverlays,
-			boolean useVolitile) {
-		if (toUpdate == null)
-			return null;
-
-		return Paint(toUpdate, null, paintOverlays, useVolitile);
-	}
-
-	public static int getMode() {
-		return _Mode;
-	}
-
-	public static Graphics createGraphics() {
-		// Error messages on start up will call this message before
-		// _DisplayGraphics has been initialised
-		if (_DisplayGraphics == null)
-			return null;
-		return _DisplayGraphics.create();
-	}
-
-	// Damaged areas pending to render. Accessessed by multiple threads
-	private static HashSet<Rectangle> damagedAreas = new HashSet<Rectangle>();
-
-	/** The clip used while paiting */
-	private static Area currentClip;
-
-	/**
-	 * The current clip that is used for painting at this instant.
-	 * 
-	 * Intention: for extra clipping within an items paint method - the clip is
-	 * lost in the graphics object for which can be regained via this method.
-	 * 
-	 * @return The current clip. Null if no clip (e.g. full screen render).
-	 */
-	public static Area getCurrentClip() {
-		return (currentClip != null) ? (Area) currentClip.clone() : null;
-	}
-
-	/**
-	 * Checks that the item is visible (on current frame && overlays) - if
-	 * visible then damaged area will be re-rendered on the next refresh.
-	 * 
-	 * @param damagedItem
-	 * @param toRepaint
-	 */
-	public static void invalidateItem(Item damagedItem, Rectangle toRepaint) {
-		// Only add area to repaint if item is visible...
-		if (ItemUtils.isVisible(damagedItem)) {
-			synchronized (damagedAreas) {
-				damagedAreas.add(toRepaint);
-			}
-		} else if (MessageBay.isMessageItem(damagedItem)) {
-			MessageBay.addDirtyArea(toRepaint);
-		}
-	}
-
-	/**
-	 * The given area will be re-rendered in the next refresh. This is the
-	 * quicker version and is more useful for re-rendering animated areas.
-	 * 
-	 * @param toRepaint
-	 */
-	public static void invalidateArea(Rectangle toRepaint) {
-		synchronized (damagedAreas) {
-			damagedAreas.add(toRepaint);
-		}
-	}
-
-	public static void clearInvalidAreas() {
-		synchronized (damagedAreas) {
-			damagedAreas.clear();
-		}
-	}
-
-	/**
-	 * Invalidates the buffered image of the current Frame and forces it to be
-	 * repainted on to the screen. Repaints all items. This is more expensive
-	 * than refresh.
-	 */
-	public static void ForceRepaint() { // TODO: TEMP: Use refresh
-		Frame current = DisplayIO.getCurrentFrame();
-
-		if (current == null)
-			return;
-		refresh(false);
-	}
-
-	public static void Repaint() { // TODO: TEMP: Use refresh
-		refresh(true);
-	}
-
-	/**
-	 * Called to refresh the display screen. Thread safe.
-	 */
-	public static void refresh(boolean useInvalidation) {
-
-		if (_DisplayGraphics == null || _MaxSize.width <= 0
-				|| _MaxSize.height <= 0)
-			return;
-
-		currentClip = null;
-		if (useInvalidation) { // build clip
-
-			synchronized (damagedAreas) {
-				if (!damagedAreas.isEmpty()) {
-
-					for (Rectangle r : damagedAreas) {
-						if (currentClip == null)
-							currentClip = new Area(r);
-						else
-							currentClip.add(new Area(r));
-					}
-					damagedAreas.clear();
-
-				} else if (MessageBay.isDirty()) {
-					// Paint dirty message bay
-					Graphics dg = _DisplayGraphics.create();
-					MessageBay.refresh(true, dg, Item.DEFAULT_BACKGROUND);
-					return;
-
-				} else
-					return; // nothing to render
-			}
-
-		} else {
-			synchronized (damagedAreas) {
-				damagedAreas.clear();
-			}
-			// System.out.println("FULLSCREEN REFRESH"); // TODO: REMOVE
-		}
-
-		Frame[] toPaint = DisplayIO.getFrames();
-		Image left = Paint(toPaint[0], currentClip);
-		Image right = Paint(toPaint[1], currentClip);
-
-		Graphics dg = _DisplayGraphics.create();
-
-		// Paint frame to window
-		Paint(dg, left, right, Item.DEFAULT_BACKGROUND);
-
-		// Paint any animations
-		PopupManager.getInstance().paintAnimations();
-
-		// Paint message bay
-		MessageBay.refresh(useInvalidation, dg, Item.DEFAULT_BACKGROUND);
-
-		dg.dispose();
-	}
-
-	/**
-	 * If wanting to refresh from another thread - other than the main thread
-	 * that handles the expeditee datamodel (modifying / accessing / rendering).
-	 * Use this method for thread safety.
-	 */
-	public static synchronized void requestRefresh(boolean useInvalidation) {
-
-		_requestMarsheller._useInvalidation = useInvalidation;
-
-		if (_requestMarsheller._isQueued) {
-			return;
-		}
-
-		_requestMarsheller._isQueued = true;
-		EventQueue.invokeLater(_requestMarsheller); // Render on AWT thread
-	}
-
-	private static RenderRequestMarsheller _requestMarsheller = new FrameGraphics().new RenderRequestMarsheller();
-
-	/**
-	 * Used for marshelling render requests from foreign threads to the event
-	 * dispatcher thread... (AWT)
-	 * 
-	 * @author Brook Novak
-	 */
-	private class RenderRequestMarsheller implements Runnable {
-
-		boolean _useInvalidation = true;
-
-		boolean _isQueued = false;
-
-		public void run() {
-			refresh(_useInvalidation);
-			_isQueued = false;
-			_useInvalidation = true;
-		}
-
-	}
-
+				item.setHighlightColorToDefault();
+			}
+		}
+		DisplayController.requestRefresh(true);
+	}
+
+	/*
+	 * 
+	 * FrameRenderPass stuff. (TODO: Not sure if this is used for anything? In Apollo. cts16)
+	 * 
+	 */
+	
 	/**
 	 * Adds a FinalFrameRenderPass to the frame-render pipeline...
@@ -1221,6 +629,6 @@
 	 * situations.
 	 * 
-	 * Although if there are multiples FinalFrameRenderPasses attatach to the
-	 * frame painter then it is not garaunteed to be rendered very last.
+	 * Although if there are multiples FinalFrameRenderPasses attach to the
+	 * frame painter then it is not guaranteed to be rendered very last.
 	 * 
 	 * @see FrameGraphics#addFinalFrameRenderPass(org.expeditee.gui.FrameGraphics.FrameRenderPass)
@@ -1236,11 +644,11 @@
 		 * 
 		 * @return The clip that the pass should use instead. i.e. if there are
-		 *         any effects that cannot invladate prior to paint call.
+		 *         any effects that cannot invalidate prior to paint call.
 		 */
-		Area paintStarted(Area currentClip);
-
-		void paintFinalPass(Graphics g);
-
-		void paintPreLayeredPanePass(Graphics g);
+		Clip paintStarted(Clip currentClip);
+
+		void paintFinalPass();
+
+		void paintPreLayeredPanePass();
 	}
 
Index: /trunk/src/org/expeditee/gui/FrameIO.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameIO.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameIO.java	(revision 1102)
@@ -195,14 +195,12 @@
 	}
 
-	public static Frame LoadFrame(String frameName, String path,
-			boolean ignoreAnnotations) {
-		if (!isValidFrameName(frameName))
-			return null;
+	public static Frame LoadFrame(String frameName, String path, boolean ignoreAnnotations)
+	{
+		if (!isValidFrameName(frameName)) return null;
 
 		String frameNameLower = frameName.toLowerCase();
 		// first try reading from cache
 		if (isCacheOn() && _Cache.containsKey(frameNameLower)) {
-			Logger.Log(Logger.SYSTEM, Logger.LOAD, "Loading " + frameName
-					+ " from cache.");
+			Logger.Log(Logger.SYSTEM, Logger.LOAD, "Loading " + frameName + " from cache.");
 			Frame frame = _Cache.get(frameNameLower);
 			return frame;
@@ -389,5 +387,5 @@
 
 	public static boolean canAccessFrame(String frameName) {
-		Frame current = DisplayIO.getCurrentFrame();
+		Frame current = DisplayController.getCurrentFrame();
 		// Just in case the current frame is not yet saved...
 		if (frameName.equals(current.getName())) {
@@ -490,9 +488,9 @@
 
 		_UseCache = false;
-		Frame fresh = FrameIO.LoadFrame(DisplayIO.getCurrentFrame().getName());
+		Frame fresh = FrameIO.LoadFrame(DisplayController.getCurrentFrame().getName());
 		_UseCache = cache;
 		if (_Cache.containsKey(fresh.getName().toLowerCase()))
 			addToCache(fresh);
-		DisplayIO.setCurrentFrame(fresh, false);
+		DisplayController.setCurrentFrame(fresh, false);
 	}
 
@@ -599,19 +597,19 @@
 
 	public static Frame LoadZero() {
-		Frame current = DisplayIO.getCurrentFrame();
+		Frame current = DisplayController.getCurrentFrame();
 		return LoadZero(current.getFramesetName(), current.getPath());
 	}
 
 	public static Frame LoadLast() {
-		Frame current = DisplayIO.getCurrentFrame();
+		Frame current = DisplayController.getCurrentFrame();
 		return LoadLast(current.getFramesetName(), current.getPath());
 	}
 
 	public static Frame LoadNext() {
-		return LoadNext(DisplayIO.getCurrentFrame());
+		return LoadNext(DisplayController.getCurrentFrame());
 	}
 
 	public static Frame LoadPrevious() {
-		return LoadPrevious(DisplayIO.getCurrentFrame());
+		return LoadPrevious(DisplayController.getCurrentFrame());
 	}
 
@@ -747,5 +745,5 @@
 		}
 
-		// Remove the old frame from the cashe then add the new one
+		// Remove the old frame from the cache then add the new one
 		// TODO figure out some way that we can put both in the cache
 		_Cache.remove(template.getName().toLowerCase());
@@ -770,5 +768,5 @@
 		Item titleItem = template.getTitleItem();
 
-		if (!DisplayIO.isTwinFramesOn() && !Justification.center.equals(((Text)titleItem).getJustification())) {
+		if (!DisplayController.isTwinFramesOn() && !Justification.center.equals(((Text)titleItem).getJustification())) {
 			if ((titleItem.getX() + 1) < template.getNameItem().getX()) {
 				while (titleItem.getSize() > Text.MINIMUM_FONT_SIZE
@@ -811,8 +809,8 @@
 	}
 
-	public static void RefreshCasheImages() {
+	public static void RefreshCacheImages()
+	{
 		SuspendCache();
-		for (Frame f : _Cache.values())
-			f.setBuffer(null);
+		for (Frame frame : _Cache.values()) frame.setBuffer(null);
 		ResumeCache();
 	}
@@ -1152,7 +1150,8 @@
 	 * @return true if the frame is in the current user profile frameset
 	 */
-	public static boolean isProfileFrame(Frame toCheck) {
-		if (toCheck.getNumber() == 0)
-			return false;
+	public static boolean isProfileFrame(Frame toCheck)
+	{
+		if (toCheck.getNumber() == 0) return false;
+		
 		return toCheck.getPath().equals(PROFILE_PATH);
 		// return toCheck.getFramesetName()
@@ -1160,5 +1159,6 @@
 	}
 
-	public static Frame LoadProfile(String userName) {
+	public static Frame LoadProfile(String userName)
+	{
 		return LoadFrame(userName + "1");
 	}
@@ -1299,5 +1299,5 @@
 		String templateLink = linker.getAbsoluteLinkTemplate();
 		String framesetLink = linker.getAbsoluteLinkFrameset();
-		String frameset = (framesetLink != null ? framesetLink : DisplayIO
+		String frameset = (framesetLink != null ? framesetLink : DisplayController
 				.getCurrentFrame().getFramesetName());
 
@@ -1322,5 +1322,5 @@
 	 */
 	public static Frame CreateNewFrameset(String name) throws Exception {
-		String path = DisplayIO.getCurrentFrame().getPath();
+		String path = DisplayController.getCurrentFrame().getPath();
 
 		// if current frameset is profile directory change it to framesets
@@ -1394,11 +1394,9 @@
 	}
 
-	public static Frame CreateFrameset(String frameset, String path,
-			boolean recreate) throws Exception {
+	public static Frame CreateFrameset(String frameset, String path, boolean recreate) throws Exception
+	{
 		String conversion = frameset + " --> ";
 
-		if (!isValidFramesetName(frameset)) {
-			throw new Exception("Invalid frameset name");
-		}
+		if (!isValidFramesetName(frameset)) throw new Exception("Invalid frameset name");
 
 		if (!recreate && FrameIO.canAccessFrameset(frameset)) {
@@ -1474,6 +1472,5 @@
 		SaveFrame(base, true);
 
-		Logger.Log(Logger.SYSTEM, Logger.NEW_FRAMESET, "Created new frameset: "
-				+ frameset);
+		Logger.Log(Logger.SYSTEM, Logger.NEW_FRAMESET, "Created new frameset: " + frameset);
 
 		return base;
